import javax.security.auth.callback.*;
import java.io.IOException;

public class LoginCallbackHandler implements CallbackHandler {

    private final String mLogPrefix = "LoginCallbackHandler::";
    private final String mUsername;
    private final String mPassword;

    public LoginCallbackHandler() {
        super();
        mUsername = null;
        mPassword = null;
    }

    public LoginCallbackHandler(String pName, String pPassword) {
        super();
        System.out.println(mLogPrefix + "(pName, pPassword) --> Entered function.");
        this.mUsername = pName;
        this.mPassword = pPassword;
    }

    @Override
    public void handle(Callback[] callbacks) throws IOException, UnsupportedCallbackException {
        System.out.println(mLogPrefix + "handle --> Entered function.");
        for (int i = 0; i < callbacks.length; i++) {
            if (callbacks[i] instanceof NameCallback && mUsername != null) {
                NameCallback nameCallback = (NameCallback) callbacks[i];
                nameCallback.setName(mUsername);
            } else if (callbacks[i] instanceof PasswordCallback) {
                PasswordCallback passwordCallback = (PasswordCallback) callbacks[i];
                passwordCallback.setPassword(mPassword.toCharArray());
            }
            else {
                System.err.println("LoginCallbackHandler::handle --> UnspportedCallBackException");
            }
        }
    }
}
